<?php

namespace Aalogics\Parcelninja\Gateway\Parcelninja;
use \Aalogics\Parcelninja\Gateway\Parcelninja\Client;
use \Aalogics\Parcelninja\Helper\Data;
use \Magento\Framework\DataObject;
use \Magento\Framework\HTTP\ZendClient;
use Magento\Quote\Model\Quote\Address\RateRequest;


class Request extends DataObject{

	/**
	 * HTTP Client
	 * @var client
	 */
	protected $client;
	
	/**
	 * Helper
	 * @var \Aalogics\Parcelninja\Helper\Data
	 */
	protected $helper;
	
	/**
	 * 
	 * @param \Aalogics\Parcelninja\Model\Gateway\Parcelninja\Api\Client $client
	 * @param \Aalogics\Parcelninja\Logger\Logger $logger
	 */
	public function __construct(
		Client $client,
		Data $helper
	) {
		$this->client = $client;
		$this->helper = $helper;
	}

	public function sendRequest($endpoint , $payload = []){
		
		try {
			$response = $this->client->makeRequest($endpoint, ZendClient::POST , $payload);
		} catch (Exception $e) {
			$this->helper->debug("Exception", $e->getMessage());

			return [];				
		}
		return $response;
	}



}